include masm32rt.inc    ; http://masm32.com/
.686p
.mmx
.xmm

include \macros\SmplMath\math.inc  ; http://sourceforge.net/projects/smplmath/

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

.data?
    pCntrlSize      PVOID ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

    mov wcex.hInstance,rv(GetModuleHandle,0)
    mov wcex.cbSize,SIZEOF WNDCLASSEX
    mov wcex.style, CS_HREDRAW or CS_VREDRAW
    mov wcex.lpfnWndProc, OFFSET WndProc
    mov wcex.cbClsExtra,NULL
    mov wcex.cbWndExtra,0
    mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
    mov wcex.lpszMenuName,NULL
    mov wcex.lpszClassName,chr$("Win32,SmplMath")
    mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
    mov wcex.hIconSm,eax
    mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
    invoke RegisterClassEx, ADDR wcex
    mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"win32,SmplMath",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,500,400,NULL,NULL,wcex.hInstance,NULL)
    invoke ShowWindow,esi,SW_SHOWNORMAL
    invoke UpdateWindow,esi

    .while 1
        invoke GetMessage,ADDR msg,NULL,0,0
        .break .if !eax || eax == -1
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
    .endw

    invoke ExitProcess,msg.wParam

main endp

CntChildProc proc hWnd:HWND,lParam:LPARAM
    
    mov eax,lParam
    inc DWORD ptr [eax]
    ret
    
CntChildProc endp

EnumChildProc proc uses edi hWnd:HWND,lParam:LPARAM
LOCAL rect[2]:RECT  
    
    mov edi,rv(GetParent,hWnd)
    invoke GetClientRect,edi,ADDR rect
    invoke GetWindowRect,hWnd,ADDR rect[16]
    invoke ScreenToClient,edi,ADDR rect[16]
    invoke ScreenToClient,edi,ADDR rect[16][8]
    
    mov eax,lParam
    mov edx,PVOID ptr [eax]
    fSlv REAL4 ptr [edx][0*4] = rect[16].left / rect.right                          ; x
    fSlv REAL4 ptr [edx][1*4] = rect[16].top / rect.bottom                          ; y
    fSlv REAL4 ptr [edx][2*4] = (rect[16].right - rect[16].left) / rect.right       ; width
    fSlv REAL4 ptr [edx][3*4] = (rect[16].bottom - rect[16].top) / rect.bottom      ; height
    m2m HWND ptr [edx][4*4],hWnd
    
    add edx,4 * (SIZEOF REAL4) + SIZEOF HWND
    mov PVOID ptr [eax],edx
    mov eax,1   
    ret
    
EnumChildProc endp

GetCntrlPos proc uses edi hWnd:HWND
LOCAL nCntrls:DWORD
LOCAL pCntrls:PVOID
    
    mov nCntrls,0
    invoke EnumChildWindows,hWnd,OFFSET CntChildProc,ADDR nCntrls
    .if nCntrls
        inc eax
        mov edx,4 * (SIZEOF REAL4) + SIZEOF HWND
        imul eax,edx
        mov edi,alloc(eax)
        mov pCntrls,edi
        invoke EnumChildWindows,hWnd,OFFSET EnumChildProc,ADDR pCntrls
        mov eax,edi
        ret
    .else
        mov eax,alloc(4 * (SIZEOF REAL4) + SIZEOF HWND)
        ret
    .endif
    
GetCntrlPos endp

ResizeCntrls proc uses esi hWnd:HWND,p:PVOID
LOCAL rect[16]:RECT 
    
    invoke GetClientRect,hWnd,ADDR rect[16]
    
    mov esi,p
    
    .while HWND ptr [esi][4*4]
        
        fSlv rect.left   = REAL4 ptr [esi][0*4] * rect[16].right
        fSlv rect.top    = REAL4 ptr [esi][1*4] * rect[16].bottom
        fSlv rect.right  = REAL4 ptr [esi][2*4] * rect[16].right
        fSlv rect.bottom = REAL4 ptr [esi][3*4] * rect[16].bottom
        
        invoke MoveWindow,HWND ptr [esi][4*4],rect.left,rect.top,rect.right,rect.bottom,TRUE
        add esi,4 * (SIZEOF REAL4) + SIZEOF HWND
    .endw
    
    ret
    
ResizeCntrls endp


WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL fSlvTLS()

    .if uMsg == WM_CLOSE
        invoke PostQuitMessage,NULL
        free pCntrlSize
    .elseif uMsg == WM_CREATE
        ; create some controls
        fn CreateWindowEx,0,"button","What ever",WS_VISIBLE or WS_CHILD,0,0,200,100,hWnd,0,0,0
        fn CreateWindowEx,0,"button","xyz",WS_VISIBLE or WS_CHILD,100,100,300,200,hWnd,0,0,0
        
        ;/* get current size an position of all controls */
        mov pCntrlSize,rv(GetCntrlPos,hWnd)
    
    .elseif uMsg == WM_SIZE
        invoke ResizeCntrls,hWnd,pCntrlSize
    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif

    xor eax,eax
    ret
WndProc endp
end main